Package org.apache.commons.dbutils

## Class DbUtils

- java.lang.Object
- - org.apache.commons.dbutils.DbUtils

-     public final class DbUtils
      extends Object

  A collection of JDBC helper methods. This class is thread safe.

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DbUtils()` | Default constructor.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static void` | `close​(Connection conn)` | Close a `Connection`, avoid closing if null.
    `static void` | `close​(ResultSet resultSet)` | Close a `ResultSet`, avoid closing if null.
    `static void` | `close​(Statement stmt)` | Close a `Statement`, avoid closing if null.
    `static void` | `closeQuietly​(Connection conn)` | Close a `Connection`, avoid closing if null and hide any SQLExceptions that occur.
    `static void` | `closeQuietly​(Connection conn, Statement stmt, ResultSet rs)` | Close a `Connection`, `Statement` and `ResultSet`.
    `static void` | `closeQuietly​(ResultSet resultSet)` | Close a `ResultSet`, avoid closing if null and hide any SQLExceptions that occur.
    `static void` | `closeQuietly​(Statement stmt)` | Close a `Statement`, avoid closing if null and hide any SQLExceptions that occur.
    `static void` | `commitAndClose​(Connection conn)` | Commits a `Connection` then closes it, avoid closing if null.
    `static void` | `commitAndCloseQuietly​(Connection conn)` | Commits a `Connection` then closes it, avoid closing if null and hide any SQLExceptions that occur.
    `static boolean` | `loadDriver​(ClassLoader classLoader, String driverClassName)` | Loads and registers a database driver class.
    `static boolean` | `loadDriver​(String driverClassName)` | Loads and registers a database driver class.
    `static void` | `printStackTrace​(SQLException e)` | Print the stack trace for a SQLException to STDERR.
    `static void` | `printStackTrace​(SQLException e, PrintWriter pw)` | Print the stack trace for a SQLException to a specified PrintWriter.
    `static void` | `printWarnings​(Connection conn)` | Print warnings on a Connection to STDERR.
    `static void` | `printWarnings​(Connection conn, PrintWriter pw)` | Print warnings on a Connection to a specified PrintWriter.
    `static void` | `rollback​(Connection conn)` | Rollback any changes made on the given connection.
    `static void` | `rollbackAndClose​(Connection conn)` | Performs a rollback on the `Connection` then closes it, avoid closing if null.
    `static void` | `rollbackAndCloseQuietly​(Connection conn)` | Performs a rollback on the `Connection` then closes it, avoid closing if null and hide any SQLExceptions that occur.
    `static void` | `rollbackQuietly​(Connection conn)` | Performs a rollback on the `Connection`, avoid closing if null and hide any SQLExceptions that occur.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DbUtils

          public DbUtils()

      Default constructor. Utility classes should not have a public or default constructor, but this one preserves retro-compatibility.
      Since:
        1.4

  - ### Method Detail

    - #### close

          public static void close​(Connection conn)
                            throws SQLException

      Close a `Connection`, avoid closing if null.
      Parameters:
        `conn` - Connection to close.
      Throws:
        `SQLException` - if a database access error occurs

    - #### close

          public static void close​(ResultSet resultSet)
                            throws SQLException

      Close a `ResultSet`, avoid closing if null.
      Parameters:
        `resultSet` - ResultSet to close.
      Throws:
        `SQLException` - if a database access error occurs

    - #### close

          public static void close​(Statement stmt)
                            throws SQLException

      Close a `Statement`, avoid closing if null.
      Parameters:
        `stmt` - Statement to close.
      Throws:
        `SQLException` - if a database access error occurs

    - #### closeQuietly

          public static void closeQuietly​(Connection conn)

      Close a `Connection`, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `conn` - Connection to close.

    - #### closeQuietly

          public static void closeQuietly​(Connection conn,
                                          Statement stmt,
                                          ResultSet rs)

      Close a `Connection`, `Statement` and `ResultSet`. Avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `conn` - Connection to close.
        `stmt` - Statement to close.
        `rs` - ResultSet to close.

    - #### closeQuietly

          public static void closeQuietly​(ResultSet resultSet)

      Close a `ResultSet`, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `resultSet` - ResultSet to close.

    - #### closeQuietly

          public static void closeQuietly​(Statement stmt)

      Close a `Statement`, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `stmt` - Statement to close.

    - #### commitAndClose

          public static void commitAndClose​(Connection conn)
                                     throws SQLException

      Commits a `Connection` then closes it, avoid closing if null.
      Parameters:
        `conn` - Connection to close.
      Throws:
        `SQLException` - if a database access error occurs

    - #### commitAndCloseQuietly

          public static void commitAndCloseQuietly​(Connection conn)

      Commits a `Connection` then closes it, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `conn` - Connection to close.

    - #### loadDriver

          public static boolean loadDriver​(ClassLoader classLoader,
                                           String driverClassName)

      Loads and registers a database driver class. If this succeeds, it returns true, else it returns false.
      Parameters:
        `classLoader` - the class loader used to load the driver class
        `driverClassName` - of driver to load
      Returns:
        boolean `true` if the driver was found, otherwise `false`
      Since:
        1.4

    - #### loadDriver

          public static boolean loadDriver​(String driverClassName)

      Loads and registers a database driver class. If this succeeds, it returns true, else it returns false.
      Parameters:
        `driverClassName` - of driver to load
      Returns:
        boolean `true` if the driver was found, otherwise `false`

    - #### printStackTrace

          public static void printStackTrace​(SQLException e)

      Print the stack trace for a SQLException to STDERR.
      Parameters:
        `e` - SQLException to print stack trace of

    - #### printStackTrace

          public static void printStackTrace​(SQLException e,
                                             PrintWriter pw)

      Print the stack trace for a SQLException to a specified PrintWriter.
      Parameters:
        `e` - SQLException to print stack trace of
        `pw` - PrintWriter to print to

    - #### printWarnings

          public static void printWarnings​(Connection conn)

      Print warnings on a Connection to STDERR.
      Parameters:
        `conn` - Connection to print warnings from

    - #### printWarnings

          public static void printWarnings​(Connection conn,
                                           PrintWriter pw)

      Print warnings on a Connection to a specified PrintWriter.
      Parameters:
        `conn` - Connection to print warnings from
        `pw` - PrintWriter to print to

    - #### rollback

          public static void rollback​(Connection conn)
                               throws SQLException

      Rollback any changes made on the given connection.
      Parameters:
        `conn` - Connection to rollback. A null value is legal.
      Throws:
        `SQLException` - if a database access error occurs

    - #### rollbackAndClose

          public static void rollbackAndClose​(Connection conn)
                                       throws SQLException

      Performs a rollback on the `Connection` then closes it, avoid closing if null.
      Parameters:
        `conn` - Connection to rollback. A null value is legal.
      Throws:
        `SQLException` - if a database access error occurs
      Since:
        1.1

    - #### rollbackAndCloseQuietly

          public static void rollbackAndCloseQuietly​(Connection conn)

      Performs a rollback on the `Connection` then closes it, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `conn` - Connection to rollback. A null value is legal.
      Since:
        1.1

    - #### rollbackQuietly

          public static void rollbackQuietly​(Connection conn)

      Performs a rollback on the `Connection`, avoid closing if null and hide any SQLExceptions that occur.
      Parameters:
        `conn` - Connection to rollback. A null value is legal.
      Since:
        DbUtils 2.0